/* audiod.cmdline.h */

/* File autogenerated by gengetopt version 2.16  */

#ifndef AUDIOD_CMDLINE_H
#define AUDIOD_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
#define CMDLINE_PARSER_PACKAGE "para_audiod"
#endif

#ifndef CMDLINE_PARSER_VERSION
#define CMDLINE_PARSER_VERSION "(paraslash 0.2.11, atomic duality)\nCopyright (c) 1997-2006 by Andre Noll\nThis is free software with ABSOLUTELY NO WARRANTY. See COPYING for details."
#endif

struct gengetopt_args_info
{
  char * user_arg;	/* run as user 'name'. Read the output of 'para_server -h' for a detailed information on this option..  */
  char * user_orig;	/* run as user 'name'. Read the output of 'para_server -h' for a detailed information on this option. original value given at command line.  */
  int loglevel_arg;	/* set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/* set loglevel (0-6) original value given at command line.  */
  int daemon_flag;	/* run as background daemon (default=off).  */
  int force_flag;	/* force startup even if socket exits (default=off).  */
  char * logfile_arg;	/* (default=stdout/stderr).  */
  char * logfile_orig;	/* (default=stdout/stderr) original value given at command line.  */
  char * mode_arg;	/* mode to use on startup (on/off/sb) (default='on').  */
  char * mode_orig;	/* mode to use on startup (on/off/sb) original value given at command line.  */
  char * socket_arg;	/* well-known socket to listen on (default=/var/paraslash/audiod_sock.<host_name>).  */
  char * socket_orig;	/* well-known socket to listen on (default=/var/paraslash/audiod_sock.<host_name>) original value given at command line.  */
  int* user_allow_arg;	/* allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, allow all users to
  connect. (default='-1').  */
  char ** user_allow_orig;	/* allow this user to connect to para_audiod.
  May be specified multiple times. If not
  specified at all, allow all users to
  connect. original value given at command line.  */
  char ** receiver_arg;	/* Select receiver.
  
  May be given multiple times, once for each
  supported audio format. receiver_spec
  consists of an audio format and the receiver
  name, separated by a colon, and any options
  for that receiver, seperated by whitespace.
  If any receiver options are present, the
  whole receiver argument must be quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
 (default='http').  */
  char ** receiver_orig;	/* Select receiver.
  
  May be given multiple times, once for each
  supported audio format. receiver_spec
  consists of an audio format and the receiver
  name, separated by a colon, and any options
  for that receiver, seperated by whitespace.
  If any receiver options are present, the
  whole receiver argument must be quoted.
  
  Example:
  
  -r 'mp3:http -i www.paraslash.org -p 8009'
 original value given at command line.  */
  int no_default_filters_flag;	/* Configure filters manually.
  
  If (and only if) this option is set, the
  --filter options take effect.  Otherwise, the
  compiled-in default filters mp3dec (oggdec)
  and wav are activated for mp3 (ogg) streams. (default=off).  */
  char ** filter_arg;	/* Select filter(s) manually.
  
  May be given multiple times. filter_spec
  consists of an audio format, the name of the
  filter, and any options for that filter.
  
  Examples:
  	-f mp3:mp3dec
  	-f 'mp3:compress --anticlip --volume 2'
  
  Note that these options are ignored by default,
  see --no_default_filters..  */
  char ** filter_orig;	/* Select filter(s) manually.
  
  May be given multiple times. filter_spec
  consists of an audio format, the name of the
  filter, and any options for that filter.
  
  Examples:
  	-f mp3:mp3dec
  	-f 'mp3:compress --anticlip --volume 2'
  
  Note that these options are ignored by default,
  see --no_default_filters. original value given at command line.  */
  char ** stream_write_cmd_arg;	/* Specify stream writer.
  
  May be given multiple times, once for each
  supported audio format. Default value is
  'para_play' for both mp3 and ogg. You can use
  the START_TIME() macro for these commands.
  Each occurence of START_TIME() gets replaced
  at runtime by the stream start time announced
  by para_server, plus any offsets..  */
  char ** stream_write_cmd_orig;	/* Specify stream writer.
  
  May be given multiple times, once for each
  supported audio format. Default value is
  'para_play' for both mp3 and ogg. You can use
  the START_TIME() macro for these commands.
  Each occurence of START_TIME() gets replaced
  at runtime by the stream start time announced
  by para_server, plus any offsets. original value given at command line.  */
  int stream_delay_arg;	/* Time to add to para_server's start_time.
  
  Amount of time to be added to the server
  stream start time for stream_write_cmd if
  START_TIME() was given. Useful for
  syncronizing the audio output of clients. (default='200').  */
  char * stream_delay_orig;	/* Time to add to para_server's start_time.
  
  Amount of time to be added to the server
  stream start time for stream_write_cmd if
  START_TIME() was given. Useful for
  syncronizing the audio output of clients. original value given at command line.  */
  int stream_timeout_arg;	/* Deactivate slot if idle for that many seconds (default='30').  */
  char * stream_timeout_orig;	/* Deactivate slot if idle for that many seconds original value given at command line.  */
  
  int help_given ;	/* Whether help was given.  */
  int version_given ;	/* Whether version was given.  */
  int user_given ;	/* Whether user was given.  */
  int loglevel_given ;	/* Whether loglevel was given.  */
  int daemon_given ;	/* Whether daemon was given.  */
  int force_given ;	/* Whether force was given.  */
  int logfile_given ;	/* Whether logfile was given.  */
  int mode_given ;	/* Whether mode was given.  */
  int socket_given ;	/* Whether socket was given.  */
  unsigned int user_allow_given ;	/* Whether user_allow was given.  */
  unsigned int receiver_given ;	/* Whether receiver was given.  */
  int no_default_filters_given ;	/* Whether no_default_filters was given.  */
  unsigned int filter_given ;	/* Whether filter was given.  */
  unsigned int stream_write_cmd_given ;	/* Whether stream_write_cmd was given.  */
  int stream_delay_given ;	/* Whether stream_delay was given.  */
  int stream_timeout_given ;	/* Whether stream_timeout was given.  */

} ;

int cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info);
int cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required);
int cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info);

void cmdline_parser_print_help(void);
void cmdline_parser_print_version(void);

void cmdline_parser_init (struct gengetopt_args_info *args_info);
void cmdline_parser_free (struct gengetopt_args_info *args_info);

int cmdline_parser_configfile (char * const filename, struct gengetopt_args_info *args_info, int override, int initialize, int check_required);

int cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* AUDIOD_CMDLINE_H */
